// ******************************************
// ** USB Mouse for the ZX81 & Other 8bits **
// **                                      **
// ** zx81keyboardadventure.com 2018       **
// ******************************************
// ** Copyright FREE for all to use        **
// ** If you like it use and improve it,   **
// ** share it and post it.                **
// ******************************************
// ** Version Date: 02/06/2018             **
// ******************************************

#include <hidboot.h>
#include <usbhub.h>
#include "ZeaMouse.h"

// Satisfy the IDE, which needs to see the include statement in the ino too.
#ifdef dobogusinclude
#include <spi4teensy3.h>
#include <SPI.h>
#endif


// **********************
// *** USB Host Setup ***
// **********************

USB     Usb;
USBHub	Hub(&Usb);
HIDBoot	<USB_HID_PROTOCOL_MOUSE>    HidMouse(&Usb);
uint32_t next_time;

// **********************************
// *** Global Variables & Classes ***
// **********************************
MouseRptParser gcMouseAction;
AtariJoystick gcJoystickAction(6,A1,7,8,A0);


void setup()
{
	Serial.begin( 115200 );
	#if !defined(__MIPSEL__)
	while (!Serial); // Wait for serial port to connect - used on Leonardo, Teensy and other boards with built-in USB CDC serial connection
	#endif
	Serial.println("Start");

	if (Usb.Init() == -1)
		Serial.println("OSC did not start.");

	delay( 200 );

	HidMouse.SetReportParser(0, &gcMouseAction);

	byte bCount;

}


void loop()
{
	byte bCount;
	Usb.Task();
	unsigned long fMouseCheck = 0;


	// Read XY movements of mouse
	for(bCount = UP; bCount < FIRE; bCount ++){

		fMouseCheck = millis() - gcMouseAction.plMovedLastMills[bCount];
		gcJoystickAction.ButtonPress(bCount, fMouseCheck);

	}

	// Read Button Press
	gcJoystickAction.ButtonPress(FIRE, gcMouseAction.plMovedLastMills[FIRE]);
}







